﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

namespace Bowlus.Azure.ServiceManagementWrapper
{
    public enum ErrorCode
    {
        MissingOrIncorrectVersionHeader,
        InvalidRequest,
        InvalidXmlRequest,
        InvalidContentType,
        MissingOrInvalidRequiredQueryParameter,
        InvalidHttpVerb,
        InternalError,
        BadRequest,
        AuthenticationFailed,
        ResourceNotFound,
        SubscriptionDisabled,
        ServerBusy,
        TooManyRequests,
        ConflictError
    }

    public enum DeploymentStatus
    {
        Running,
        Suspended,
        RunningTransitioning,
        SuspendedTransitioning,
        Starting,
        Suspending,
        Deploying,
        Deleting
    }

    public enum RoleInstanceStatus
    {
        Initializing,
        Ready,
        Busy,
        Stopping,
        Stopped,
        Unresponsive
    }

    public enum OperationState
    {
        InProgress,
        Succeeded,
        Failed
    }

    public enum KeyType
    {
        Primary,
        Secondary
    }

    public enum DeploymentSlotType
    {
        Staging,
        Production
    }

    public enum UpgradeType
    {
        Auto,
        Manual
    }

    public enum CurrentUpgradeDomainState
    {
        Before,
        During
    }
}