﻿namespace Bowlus.AppHost
{
    using Bowlus.Common;

    using Microsoft.Practices.Unity;

    public static class ContainerBootstrapper
    {
        public static void RegisterTypes(IUnityContainer container)
        {
            CommonContainerBootstrapper.RegisterCommonDependencies(container);

            container.RegisterType<IAppRepository, StorageAppRepository>(
                new ContainerControlledLifetimeManager(),
                new InjectionConstructor("System.ConnectionString"));

            container.RegisterInstance(typeof(AppHostManager), new ContainerControlledLifetimeManager());
        }
    }
}