﻿// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

namespace Bowlus.Common.ServiceManagement
{
    using System.ServiceModel;
    using System.ServiceModel.Channels;

    public static class Constants
    {
        public const string ServiceManagementNS = "http://schemas.microsoft.com/windowsazure";
        public const string VersionHeaderName = "x-ms-version";
        public const string OperationTrackingIdHeader = "x-ms-request-id";
        public const string DefaultVersionHeaderContent = "2009-10-01";
        public const string ServiceManagementEndpoint = "https://management.core.windows.net";

        public static Binding ServiceManagementWebHttpBinding
        {
            get
            {
                var binding = new WebHttpBinding(WebHttpSecurityMode.Transport);
                binding.Security.Transport.ClientCredentialType = HttpClientCredentialType.Certificate;
                binding.ReaderQuotas.MaxStringContentLength = 67108864;
                return binding;
            }
        }
    }
}