namespace Bowlus.FrontEnd.RequestRouting.ApplicationDeployment
{
    using Bowlus.Common;
    using Bowlus.Common.DeploymentActions;

    public class AddApplicationRequest : ApplicationDeploymentRequest
    {
        public AddApplicationRequest(TenantDeployment tenantDeployment, ApplicationHost applicationHost)
            : base(tenantDeployment)
        {
            this.ToHost = applicationHost;
        }

        protected override string RequestType
        {
            get
            {
                return DeploymentActionType.DeployToAppHost;
            }
        }

        private ApplicationHost ToHost { get; set; }

        public override void MakeDeploymentRequest()
        {
            this.TenantDeployment.Status = TenantDeploymentStatus.DeployRequestSubmitted;
            this.TenantDeployment.DeploymentAction = this.RequestType;
            this.TenantDeployment.AppHostInstanceId = this.ToHost.InstanceId;
            this.TenantDeployment.AppHostInstanceIp = this.ToHost.ApphostHttpEndpoint.Address.ToString();

            TenantDeploymentsStore.UpdateDeploymentStore(this.TenantDeployment);
        }
    }
}