﻿namespace Bowlus.RequestRouting.Tests.RequestRoutingManagerTests
{
    using Bowlus.RequestRouting.InfrastructureServices;
    using Bowlus.TestSupport;

    using Microsoft.VisualStudio.TestTools.UnitTesting;

    using Moq;

    public class given_a_router : ArrangeActAssert
    {
        protected RequestRoutingManager RequestRoutingManager;

        protected Mock<IServerManager> serverManagerMock;

        protected IArrConfigManager arrConfigManager;

        protected override void Arrange()
        {
            this.serverManagerMock = new Mock<IServerManager>();
            this.arrConfigManager = new ArrConfigManager(this.serverManagerMock.Object, "FrontEnd");

            this.RequestRoutingManager = new RequestRoutingManager(this.arrConfigManager);
        }
    }

    [TestClass]
    public class when_initializing : given_a_router
    {
        protected override void Arrange()
        {
            this.RequestRoutingManager.Initialize();
        }

        [TestMethod]
        public void then_forwarder_site_configured_correctly()
        {
            serverManagerMock.Verify();
        }
    }
}